const select = (x, y, r) => {
    let cols = [];
    y[r].forEach(i => {
        x[i].forEach(j => {
            y[j].forEach(k => {
                if (k != i) {
                    let c = x[k].indexOf(j);
                    if (c >= 0) {
                        x[k].splice(c, 1);
                    }
                }
            })
        })
        cols.push(x[i]);
        delete x[i];
    });
    return cols;
}

const deselect = (x, y, r, cols)  => {
    y[r].reverse().forEach(i => {
        x[i] = cols.pop();
        x[i].forEach(j => {
            y[j].forEach(k => {
                if (k !== i) {
                    x[k].push(j);
                }
            })
        })
    })
    y[r].reverse();
}

const s = (x, y, solution=[], firstTime = true) => { 
    if (firstTime) {
        s.riesenia = [];
        s(x, y, solution, false);
        return s.riesenia;
    }
    if(Object.keys(x).length === 0) {
        let a = []
        for (let i = 0; i < solution.length; i++) {
            a.push(solution[i]);
        }
        s.riesenia.push(a);

    } else {
        let c = Object.keys(x).reduce((a, b) => x[a].length > x[b].length ? b : a);
        x[c].forEach(r => {
            solution.push(r);
            let cols = select(x, y, r);
            s(x, y, solution, false);
            deselect(x, y, r, cols);
            solution.pop();
        })
    }
}

const exact_cover = (x, y = undefined) => {
    let b = {};
    x.forEach(e => b[e] = []);
    for (k in y) {
        y[k].forEach(j => {
            b[j].push(k);
        })
    }
    return [b, y];
}

const bigMatrix = () => {
    let a = [];
    for (let i = 0; i < 729; i++) {
        a[i] = new Array(324).fill(0);
        a[i][Math.floor(i/9)] = 1;
        a[i][81 + 9*(Math.floor(i/81)) + i%9] = 1;
        a[i][162 + i%81] = 1;
        a[i][243 + i%9 + 9*Math.floor((i%81)/27) + 27*Math.floor(i/243)] = 1;
    }
    return a;
}

const rewriteToDictionary =  (matrix) => {
    const r = (matrix.length);
    const s = (matrix[0].length);
    let y = {};
    for (let i = 0; i < r; i++) {
        y[i] = [];
        for (let j = 0; j < s; j++) {
            if (matrix[i][j] === 1) {
                y[i].push(j);
            }
        }
    }
    return y;
}

const prepare = (sudoku) => {
    let a = [...Array(324).keys()];
    let b = rewriteToDictionary(bigMatrix());
    [a, b] = exact_cover(a, b);
    let cols = [];
    for (let i = 0; i < sudoku.length; i++) {
        if (sudoku[i] !== '0') {
            let c = 9*i + Number(sudoku[i]) - 1;
            cols.push(c);
            b[c].forEach(j => {
                if (a[j] == undefined) {
                    return;
                }
                a[j].forEach(k => {
                    b[k].forEach(l => {
                        if (l != j) {
                            let d = a[l].indexOf(k);
                            if (d >= 0) {
                                a[l].splice(d, 1);
                            }
                        }
                    })
                })
                delete a[j];
            });
        }
    }
    return [a, b, cols];
}

const rewriteSolution = (solution) => {
    let a = [];
    for (let j = 0; j < 9; j++) {
        a[j] = new Array(9).fill(0);      
    }
    for (let j = 0; j < 81; j++) {
         let k = solution[j];
         a[Math.floor(Math.floor(k/9)/9)][Math.floor(k/9)%9] = k%9 + 1;
    }
    return a;
}

module.exports.solve = function(x, y = undefined) {
    if (typeof x == 'string') {
        let [a, b, sol] = prepare(x);
        let sols = s(a, b, sol);
        for (let i = 0; i < sols.length; i++) {
            sols[i] = rewriteSolution(sols[i]);
        }
        return sols;
    }
    if (!y) {
        b = rewriteToDictionary(x);
        a = [...Array(x[0].length).keys()];
        [a, b] = exact_cover(a, b);
        return s(a, b);
    }
    [x, y] = exact_cover(x, y);
    return s(x, y);
}

// let x = {
//     1: ['A', 'B', 'H'],
//     2: ['E', 'F', 'H'],
//     3: ['D', 'E', 'H'],
//     4: ['A', 'B', 'C', 'G'],
//     5: ['C', 'D', 'G'],
//     6: ['D', 'E', 'G'],
//     7: ['A', 'C', 'E', 'F', 'H']
// }

// let x = [1, 2, 3, 4, 5, 6, 7];

// let y = {
//     'A': [1, 4, 7],
//     'B': [1, 4],
//     'C': [4, 5, 7],
//     'D': [3, 5, 6],
//     'E': [2, 3, 6, 7],
//     'F': [2, 7],
//     'H': [3, 7, 1, 2],
//     'G': [4, 5, 6]
// }

// let sols = this.solve(x, y);

// console.log(sols);

// let sud1 = '000004009050120000000000085009076400020080306005400000090000100000090007060032900';
// let sud2 = '050020108000100200820900050090540070047000083080000000000200004600030000210000000';
// let sud3 = '600010080400070000790300100000500004004003050500000003006000300000600970070030406';


// let sls = solve(sud3);

// console.log(sls.length);

// for (let i = 0; i < sls.length; i++) {
//     console.log(`Solution No. ${i+1}:`);
//     console.log(sls[i]);
// }

// let mat = [[1, 0, 0, 1, 0, 0, 1],
//         [1, 0, 0, 1, 0, 0, 0],
//         [0, 0, 0, 1, 1, 0, 1],
//         [0, 0, 1, 0, 1,	1, 0],
//         [0, 1, 1, 0, 0, 1, 1],
//         [0, 1, 0, 0, 0, 0, 1]];

// console.log(mat);
// let r = this.solve(mat);
// console.log(r);

